/****************************************************************/
/*  buttons.h                                                   */
/*                                        */
/*  :      Alex                                            */
/*              e-mail: al.kl@list.ru                           */
/*              url:    http://forum.chipmk.ru                  */
/****************************************************************/

/****************************************************************/
#define PERIOD_BUTT_TICK    10      //     .
#define BUTTON_ACT_LEVEL    0       //   
/****************************************************************/
typedef struct {
    unsigned        stat: 1 ;
    unsigned        prev: 1 ;
    unsigned        click: 1;
    unsigned int    cnt_ms  ;
}T_Butt;
/****************************************************************/
#define Butt_Init(_name, _port_name, _bit_num)                 \
T_Butt  _name;                                                  \
const unsigned char _name##_bit = _bit_num;                    \
const unsigned int  _name##_port = (unsigned int)&_port_name
/****************************************************************/
#define Butt_Tick(_name)                            \
_name.stat=!BUTTON_ACT_LEVEL;                       \
if(*((unsigned int*)_name##_port)&(1<<_name##_bit)) \
    _name.stat=BUTTON_ACT_LEVEL;                    \
if(_name.prev && !_name.stat && (_name.cnt_ms<1000)) \
    _name.click=1;                                  \
if(_name.stat)                                      \
    _name.cnt_ms+=PERIOD_BUTT_TICK;                 \
else                                                \
    _name.cnt_ms=0;                                 \
_name.prev=0;                                       \
if(_name.stat)                                      \
    _name.prev=1
/****************************************************************/



