// 2    PIC12F675
// HI-TECH v9.50PL2
//Autor:   



#include <htc.h>
#include "buttons.h"
		/*  */
__CONFIG (INTIO &UNPROTECT &UNPROTECT &BORDIS &MCLRDIS &PWRTEN &WDTDIS);


#define Out				  GPIO		//
#define Off_Led			  GPIO=0;	// 

//   Pulse
const Green_Led	   	=0b00010000;// 
const Red_Led		=0b00100000;//
const Botch_Led		=0b00110000;//


Butt_Init(Mus_Butt, GPIO, 2);// Stop/Run
Butt_Init(Stop_Butt, GPIO, 3);// Mus/Auto


//  
static volatile near unsigned int   TMR1    @ 0x00E;
signed char volatile cnt;//   ,  
char i,n;				// 
char step=0,n_step=0;//   switch
bit	 stop=0,mus=0;//,paus_ok=0,test=0,ok_fl=0;		//

/*************** *************************/
void interrupt _isr(void)
{
    if(TMR1IF)	{         //    
        TMR1IF=0;       //   
        TMR1-=10000;     //    10000 
						// ( 4 - 10).
    
        if(cnt<0)       //   
            cnt++;      //     .
      	
		Butt_Tick(Stop_Butt);     //   Stop		
		Butt_Tick(Mus_Butt);	//   Mus
				}

}
///**********  *********
void init(void)		
{		
	CMCON=0b00010100;		//    Vref
	VRCON=0b10000100; 		//   1.88V
	TRISIO=0b00001111;		//    GPIO
	ANSEL=0b00010011; 		// Fosc/8, AN0,AN1
	OPTION=0b00000101;		// TMR0 1:64
	WPU=0b00000100;			//  Stop   
	
	GPIO=0;					// 
	ADCON0=0b00000001;	 	//  , AN0   
	
	TMR1ON=1;       		//  TMR1
	TMR1IF=0;       		//    TMR1
	TMR1IE=1;       		//    TMR1
	TMR1=-10000;     		//  TMR1  10000 /

	PEIE=1;         		//    
	GIE=1;          		//  
}
//----------------------- ---------------------------
//  50   150
void pulse (unsigned char led)
{
switch(step){
	case 0:	GPIO=led;		// 
			cnt=-5;step++;//  50 ,   
			
	case 1:	if(cnt>=0){     //   , ..    
        	Off_Led;		// 
			cnt = -10; step++;} break; 	//   100 
        							
	case 2:	if(cnt>=0){		// 150
			step=0; n_step++;} 
			}
}
//----------------------------------------------------------------
//*************************  ADC  ***************
void adc_comp (){
switch(step){

	case 0:	if(!mus){
			GODONE=1;			// ADC
			while (GODONE);		//   
			cnt= -(ADRESH/2); //   /2 
			step++;}		//     1
			else if(COUT){		//  Mus  
					cnt=-3;	//  30
					step++;}			
 					break;
	
	case 1:		if(cnt>=0){n_step++; //  
							step=0;} 
							break;				
			}
				}

//------------------------------------------------------------------------
void main (){ 		/* */
init();			//

while(1){		// 

if(stop)goto metka;				//  Stop/Run

switch(n_step){		//*********** 1******************
	
	case 0: adc_comp ();
							break;
	case 1: pulse(Green_Led);	//
			 				break;
	case 2: i++;			//   
			n_step--;
				if(i>=4){	//  4 
					i=0;
					n_step=3;}	//   
							break;
	
	case 3:	adc_comp ();
							break;
	case 4: pulse(Red_Led);	//
			 				break;
	case 5: i++;			//   
			n_step--;
				if(i>=4){	//  4 
					i=0;
					n_step=0;		
					n++;	
						if(n>=10){//  10 
						n=0;		
						n_step=6;}
						 } 
							break;

//****************************2**************************************			 

	case 6:	adc_comp ();
							break;
	case 7: pulse(Green_Led); 
							break;
	case 8:	adc_comp ();
							break;
	case 9: pulse(Red_Led); 
							break;
	case 10:n++;		
			n_step=6;	
				if(n>=30){//  30 
					n=0;		
					n_step=11;
						 } 
							break;

//***************************3***************************************
	case 11: adc_comp ();
							break;
	case 12: pulse(Botch_Led); 
							break;
	case 13: n++;		
			 n_step=11;	
				if(n>=30){//  30 
					n=0;		
					n_step=14;
						 } 
							break;
	
//***************************4**************************************
	case 14: adc_comp ();
							break;
	case 15: pulse(Green_Led); 
							break;
	case 16: pulse(Red_Led); 
							break;
	case 17: adc_comp ();
							break;
	case 18: pulse(Red_Led); 
							break;
	case 19: pulse(Green_Led); 
							break;
	case 20: n++;		
			 n_step=14;	
				if(n>=20){//  20 
					n=0;		
					n_step=0;
						 } 
							break;

}	
//**************** ***************************************
metka:	NOP();

if(Stop_Butt.click){        //    
        Stop_Butt.click=0;  //  
        Off_Led;			//  
		stop = !stop;       //   
    				}

if(Mus_Butt.click){        //    
        Mus_Butt.click=0;          //  
        mus = !mus;                 //   mus
 		}
}
}